Rem --- eWON start section: Application
Rem --- eWON user (start)
Watchdog_Overflow:
  If ((Tank_Level@>98) And (Input_Faucet@=1)) Then
    Input_Faucet@ = 0
    Z$="Close Input_Faucet"
    Logevent Z$
    gosub LogFile
    print time$;" close Input"
    AutoFill=0  
    PrgAction=1
  Endif
Return

ScheduledProcess:
  gosub Scheduled_Output
  gosub AutoFill
  gosub SendReport
end

Scheduled_Output:
  A$ = time$
  CurrentHour = val(A$(12 to 13))
  if (CurrentHour<>LastHour) then
    LastHour = CurrentHour
    Output_Faucet@=1
    ontimer 4,"goto Close_Output"
    tset 4,15
    Z$="Open Output_Faucet: hourly scheduled"
    logevent Z$
    gosub LogFile
    print time$;" open Output"
    PrgAction=1
  endif
return

Close_Output:
  Output_Faucet@=0
  tset 4,0
  Z$="Close Ouptut_Faucet: Hourly scheduled"
  logevent Z$
  gosub LogFile
  print time$;" close Output"
  PrgAction=1
end

AutoFill:
  If ((AutoFill=0) and (Tank_Level@<30)) then
    AutoFill=1
    Input_Faucet@=1
    Z$="Autofill : start"
    Logevent Z$
    gosub LogFile
    Print time$;" Autofill : start"
    PrgAction=1
  Endif
Return

LogFile:
  open "file:/usr/Logfile.txt" for text append as 1
  put 1,time$;Z$
  close 1  
return

SendReport:
  A$ = time$
  CurrentDay = val(A$(1 to 2))
  if (CurrentDay<>LastDay) then
    LastDay=CurrentDay
    sendmail "prk@actl.be","","Daily activities","[$dtUF$uf/Logfile.txt]"
    SendReport_ID = Getsys PRG,"ACTIONID"
  endif
return
end

ProcessAction:
  y% = Getsys PRG,"EVTINFO"
  Print Time$;" evtinfo ";y%
  If (y%=SendReport_ID) Then
    Setsys PRG,"ACTIONID",y%
    y% = Getsys PRG,"ACTIONSTAT"
    Print Time$;" actionstat ";y%
    If (y%=0) Then
      rem  Send report is done with success
      rem  We can clear the Logfile
      open "file:/usr/Logfile.txt" for text output as 1
      close 1
      print time$;" Logfile cleared"
    Endif
  Endif
End

MonitorInputFaucet:
  if (PrgAction=0) then
    if (Input_Faucet@=1) then
      Z$ = "Manual Open Input_Faucet"
    else
      Z$ = "Manual Close Input_Faucet"
    endif
    gosub LogFile
    logevent Z$
  endif
  PrgAction=0
end

MonitorOutputFaucet:
  if (PrgAction=0) then
    if (Output_Faucet@=1) then
      Z$ = "Manual Open Output_Faucet"
    else
      Z$ = "Manual Close Output_Faucet"
    endif
    gosub LogFile
    logevent Z$
  endif
  PrgAction=0
end

Rem --- eWON user (end)
End
Rem --- eWON end section: Application

Rem --- eWON start section: Simulation
Rem --- eWON user (start)
Simulation:
  if (Input_Faucet@=1) then
    Tank_level@ = Tank_level@ + 1
  endif
  
  if (Output_Faucet@=1) then
    Tank_Level@ = Tank_Level@ - 0.5
  endif
  
end
Rem --- eWON user (end)
End
Rem --- eWON end section: Simulation

Rem --- eWON start section: Cyclic Section
ewon_cyclic_section:
Rem --- eWON user (start)
Gosub Watchdog_Overflow
Rem --- eWON user (end)
End
Rem --- eWON end section: Cyclic Section

Rem --- eWON start section: Init Section
ewon_init_section:
Rem --- eWON user (start)
  Tank_level@ = 50.0

  A$ = time$
  LastHour = val(A$(12 to 13))
  LastDay = val(A$(1 to 2))

  AutoFill=0
  PrgAction=0
  
  ontimer 1,"goto ScheduledProcess"
  tset 1,10

  onstatus "goto ProcessAction"
  
  ontimer 2,"goto simulation"
  tset 2,1
  
  onchange "Input_Faucet","goto MonitorInputFaucet"
  onchange "Output_Faucet","goto MonitorOutputFaucet"
  
Rem --- eWON user (end)
End
Rem --- eWON end section: Init Section
